use <9g_servo.scad>

$fn = 100;
X = 0.5;

translate([-5,-4.5,0]) base();
translate([0,15,0]) bat();
translate([55,36,0]) clamp4();
translate([55,32,0]) clamp1();
translate([55,23,0]) clamp3();

//base2();

module base2(){
	difference(){

		//translate([-100-5,-37-5,0]) color("green") square([184,54.5]);

      //translate([79,-42,-1]) cylinder( r=5/2, h=10 ); 
      //translate([79-184,-42,-1]) cylinder( r=5/2, h=10 ); 
      //translate([79,12.5,-1]) cylinder( r=5/2, h=10 ); 
      //translate([79-184,12.5,-1]) cylinder( r=5/2, h=10 );
 
      hull(){
        translate([79,-42,0]) circle( r=5/2); 
        translate([79-184,-42,0]) circle( r=5/2 ); 
        translate([79,12.5,0]) circle( r=5/2 ); 
        translate([79-184,12.5,0]) circle( r=5/2 ); 
      }

		translate([12,7.5,0]) circle( r=3/2 ); 
      //translate([12,7.5,-1]) cylinder( r=3/2, h=10 ); 


		translate([28,-12.5,0]) circle( r=3/2 );
      //translate([28,-12.5,-1]) cylinder( r=3/2, h=10 ); 

		translate([28,-26.5,0]) circle( r=3/2 );
      //translate([28,-26.5,-1]) cylinder( r=3/2, h=10 ); 

		translate([28+25,-12.5,0]) circle( r=3/2 );
      //translate([28+25,-12.5,-1]) cylinder( r=3/2, h=10 ); 

		translate([28+25,-26.5,0]) circle( r=3/2 );
      //translate([28+25,-26.5,-1]) cylinder( r=3/2, h=10 ); 
 
		translate([-4.25,-14.75,0]) circle( r=3/2 );
      //translate([-4.25,-14.75,-1]) cylinder( r=3/2, h=10 ); 

		translate([-4.25,-14.75-18,0]) circle( r=3/2 ); 
      //translate([-4.25,-14.75-18,-1]) cylinder( r=3/2, h=10 ); 

		translate([-100,-36.5,0]) circle( r=3/2 );
      //translate([-100,-36.5,-1]) cylinder( r=3/2, h=10 ); 

		translate([-100,7,0]) circle( r=3/2 ); 
      //translate([-100,7,-1]) cylinder( r=3/2, h=10 ); 

		translate([74,7,0]) circle( r=3/2 ); 
      //translate([74,7,-1]) cylinder( r=3/2, h=10 ); 

		translate([74,-36.5,0]) circle( r=3/2 ); 
      //translate([74,-36.5,-1]) cylinder( r=3/2, h=10 ); 

		translate([43.25,-34.3,0]) circle( r=3/2 );  
      //translate([43.25,-34.3,-1]) cylinder( r=3/2, h=10 ); 

		translate([75,-26.5,0]) circle( r=3/2 ); 
      //translate([75,-26.5,-1]) cylinder( r=3/2, h=10 );
 
		translate([75,-26.5+14,0]) circle( r=3/2 ); 
      //translate([75,-26.5+14,-1]) cylinder( r=3/2, h=10 );
	}
}

module base1(){
  difference(){
    translate([0,0,6]) rotate([45,180,0]) switches();
    translate([-90,-40,-10]) cube([100,50,10]);
    translate([-70,-38,-10]) cube([100,10,50]);
  }
}

module base(){
  difference(){  
    union(){
      difference(){
        translate([-100,-37.5,0]) color("grey") cube([184,54.5,2.5]);
        translate([-66,-35,0.75]) color("grey") cube([30,32,10]);

        translate([20,-5,0.75]) GPIO();
        translate([28,-4,-5]) cube([40,14,10]);

        translate([5+2.75,-3+0.2,0.75]) rotate([0,0,180]) sensor();
        translate([-25+2.75,-16.25,-5]) cube([19,12,10]);

        translate([5+2.75,-21+0.2,0.75]) rotate([0,0,180]) sensor();
        translate([-25+2.75,-16.25-18.25,-5]) cube([19,12,10]);

        translate([-40,-31-2.25,0.75]) cube([20,10,10]);
        translate([-40,-13-2.25,0.75]) cube([20,10,10]);
        translate([-40,-13-2.25,0.75]) cube([20,10,10]);

        translate([-18.5,0,1]) cube([39,15.5,5]);
        translate([7.5,-33,1]) cube([13,33.5,5]);
        translate([9.5,-5,1]) rotate([0,0,45]) cube([8,8,10]);

        translate([-17,1.25,-5]) cube([30,13,10]);
        translate([9.25,-32.5,-5]) cube([10,41,10]);
      }
      translate([-2+2.75,-7.25-3,0]) cylinder( r=5/2, h=1.5);
      translate([-2+2.75,-7.25-21,0]) cylinder( r=5/2, h=1.5); 
    }

    translate([20.5-3.5,15.5-3.5,-5]) cylinder( r=3/2, h=15); 

    translate([28+5,-8,-5]) cylinder( r=3/2, h=15);
    translate([28+5,-22,-5]) cylinder( r=3/2, h=15);

    translate([28+30,-8,-5]) cylinder( r=3/2, h=15);
    translate([28+30,-22,-5]) cylinder( r=3/2, h=15);
 
    translate([-2+2.75,-7.25-3,-5]) cylinder( r=3.1/2, h=15);
    translate([-2+2.75,-7.25-21,-5]) cylinder( r=3.1/2, h=15); 

    translate([-100+5,-37+5,-5]) cylinder( r=3/2, h=15); 
    translate([80-5+4,-37+5,-5]) cylinder( r=3/2, h=15); 
    translate([80-5+4,8+3.5,-5]) cylinder( r=3/2, h=15); 
    translate([-100+5,8+3.5,-5]) cylinder( r=3/2, h=15);  

    translate([76+4,-22,-5]) cylinder( r=3/2, h=15); 
    translate([76+4,-8,-5]) cylinder( r=3/2, h=15); 

    translate([70+2.75+0.5,-35,1]) translate([0,0,3.2+1]) rotate([-90-45,0,0]) base1();
    translate([22.25+0.5,-33.25,1]) cube([51,3.5,10]);
    translate([42.25+0.5,-33.25,1]) cube([11,10,10]);
    translate([69.5+0.5,-33.25,1]) cube([3.75,15,10]);
    translate([22.25+0.5,-33.25,1]) cube([3.75,15,10]);
 
    translate([45+2.75+0.5,-29.85,-5]) cylinder( r=3.25/2, h=15); 
  }

  translate([-70,10,1]) cube([5,3,5]);
  translate([-70,2,1]) cube([5,3,5]);
  translate([-70,3.5,4.5]) cube([5,8,2]);

  translate([-36,10,1]) cube([5,3,5]);
  translate([-36,2,1]) cube([5,3,5]);
  translate([-36,3.5,4.5]) cube([5,8,2]);

  translate([-37+2.5,-20.75,0]) color("grey") cube([42,3,10]);
  translate([-83,-3,1]) color("grey") servo();
  translate([-85,-5,1]) color("grey") cube([6,12,3.8]);
 
  translate([64.5+1,11,2.5]) clamp2();
  translate([20,11,2.5]) clamp2();
  translate([-15.5+8,0,2.5]) rotate([0,0,180]) clamp2();

  translate([-26.5+2.75,-21,2.5]) clamp2();
  translate([-23.5+2.75,-17.5,2.5]) rotate([0,0,180]) clamp2();

  //translate([20,-5,1]) GPIO();
  //translate([5,-3,1]) rotate([0,0,180]) sensor();
  //translate([5,-21,1]) rotate([0,0,180]) sensor();

  //translate([-65,-35.75,7.5]) bat();
  //translate([-30,-1,1]) patch_board();

  //translate([28+9,-15,3]) rotate([-90,0,90]) clamp();

  //translate([-83,-3,11.5]) rotate([-90,0,180]) 9g_motor();

  //translate([69,-35+0.3,5]) translate([0,0,3.2+1]) rotate([-90-45,0,0]) base1();

}

module switches(){
  difference(){
    union(){
      translate([0,0,5]) rotate([45,0,0]){
        difference(){
          translate([0,0,0]) cube([50,3,25]);
          translate([50/2,5,(25/2)+2]) rotate([90,0,0]) cylinder(r=6.5/2, h=15);
          translate([(50/2)-15,5,(25/2)+2]) rotate([90,0,0]) cylinder(r=7.5/2, h=15);
          translate([(50/2)+15,5,(25/2)+2]) rotate([90,0,0]) cylinder(r=5.2/2, h=15);
        }
      }
      translate([0,-0.85,0]) cube([50,3,7.5]);
      translate([20,-4,0]) cube([10,5,10]);

      difference(){
        union(){
          translate([0,-18,0]) cube([3,18,23]);
          translate([50-3,-18,0]) cube([3,18,23]);
        }
        translate([-5,0,5]) rotate([45,0,0]) translate([0,0,0]) cube([75,20,25]);
      } 
    }
    translate([25,-1,-5])  cylinder(r=3/2, h=30);
    translate([22.5,-3,7.5]) cube([5,5,10]);
    translate([0,-20,-20]) rotate([45,0,0]) translate([0,0,0]) cube([75,20,25]);
  }
}

module clamp4(){
  difference(){
    translate([-10,0,0]) cube([22,8,3]);
    translate([7,4,-1]) rotate([0,0,0]) cylinder( r=3/2, h=15);
    translate([-7,4,-1]) rotate([0,0,0]) cylinder( r=3/2, h=15);
  }
}

module clamp3(){
  difference(){
    union(){
      difference(){
        translate([0,-2,0]) cylinder(r=9/2, h=8);
        translate([0,-2,-5]) cylinder(r=5/2, h=15);
      }
      translate([-20/2,-3,0]) cube([20,3,8]);
    }
    translate([-30/2,0,-5]) cube([25,10,15]);
    translate([-5/2,-3,-5]) cube([5,10,15]);

    translate([7,-10,4]) rotate([-90,0,0]) cylinder( r=3/2, h=15);
    translate([-7,-10,4]) rotate([-90,0,0]) cylinder( r=3/2, h=15);

  }
}

module clamp2(){
  difference(){
    union(){
      translate([0,0,0]) rotate([45,0,0]) cube([3,5,5]);
      translate([0,0,0]) cube([3,5,5]);
    }
    translate([-1,2,0]) cube([10,10,10]);
    translate([-1,-5,2]) cube([10,10,10]);
    translate([-1,-2.5,0]) rotate([45,0,0]) cube([5,5,5]);
  }     
}

module clamp1(){
  difference(){
    union(){
      difference(){
        translate([0,-2,0]) cylinder(r=9/2, h=8);
        translate([0,-2,-5]) cylinder(r=5/2, h=15);
      }
      translate([-20/2,-3,0]) cube([22,3,8]);
    }
    translate([-30/2,0,-5]) cube([30,10,15]);
    translate([-5/2,-3,-5]) cube([5,10,15]);

    translate([7,-10,4]) rotate([-90,0,0]) cylinder( r=3/2, h=15);
    translate([-7,-10,4]) rotate([-90,0,0]) cylinder( r=3/2, h=15);
 
    //translate([10,-1,-5]) cube([3,10,15]);
  }
}

module clamp(){
  difference(){
    union(){
      difference(){
        translate([0,-2,0]) cylinder(r=9/2, h=8);
        translate([0,-2,-5]) cylinder(r=5/2, h=15);
      }
      translate([-20/2,-3,0]) cube([22,3,8]);
    }
    translate([-30/2,0,-5]) cube([30,10,15]);
    translate([-5/2,-3,-5]) cube([5,10,15]);

    translate([7,-10,4]) rotate([-90,0,0]) cylinder( r=3/2, h=15);
    translate([-7,-10,4]) rotate([-90,0,0]) cylinder( r=3/2, h=15);
 
   translate([10,-1,-5]) cube([3,10,15]);
  }
}

module bat(){
  difference(){
    union(){
      translate([-1,-1,0]) hull(){
        translate([6,9,0]) cylinder(r=5, h=1.5);
        translate([23,9,0]) cylinder(r=5, h=1.5);
        translate([6,26,0]) cylinder(r=5, h=1.5);
        translate([23,26,0]) cylinder(r=5, h=1.5);
      }
      translate([-18.5,(30/2),0]) cube([20.25,3,3]);
    }
    translate([27/2,33/2,-1]) cylinder(r=7/2, h=15);
    translate([27/2,(33/2)+8,-1]) cylinder(r=7/2, h=15);
    translate([27/2,(33/2)-8,-1]) cylinder(r=7/2, h=15);

    translate([(27/2)+8,33/2,-1]) cylinder(r=7/2, h=15);
    translate([(27/2)-8,33/2,-1]) cylinder(r=7/2, h=15);

    translate([(27/2)-8,(33/2)-8,-1]) cylinder(r=7/2, h=15);
    translate([(27/2)-8,(33/2)+8,-1]) cylinder(r=7/2, h=15);

    translate([(27/2)+8,(33/2)-8,-1]) cylinder(r=7/2, h=15);
   translate([(27/2)+8,(33/2)+8,-1]) cylinder(r=7/2, h=15);
  }

  difference(){
    union(){
      translate([-27,12.25,0]) cube([7.5,5,5.5]);
      translate([-27,12,0]) cylinder( r=10.5/2, h=5.5);
    }
    translate([-27,12,1])  cylinder( r=7.1/2, h=15);
    translate([-27,12,-5])  cylinder( r=2/2, h=15);
    translate([-20-3.25,(30/2)-2, 1.0]) cube([10,3.5,3.5]);
 }
}

module servo(){
	difference(){
		union(){
			translate([-16,-4.25,0]) cube([5,5,15]);
			translate([12,-4.25,0]) cube([5,5,15]);
		}
		translate([14.75,-7,10]) rotate([-90,0,0]) cylinder( r=2/2, h=15);
		translate([-13.75,-7,10]) rotate([-90,0,0]) cylinder( r=2/2, h=15);
	}
	
	difference(){
     translate([-30/2,-5,0]) cube([30,7.5,3.8]);
     translate([-(20/2)+0.5,-2,-5]) cube([20,10,15]);
	}		
}
  
module sensor(){
  difference(){
    translate([0,0,0]) cube([31.25+X,14.35+X,3]);
    translate([7,14.5/2,-5]) cylinder(r=3/2, h=15);
  }
  translate([31.5,0,3]) color("green") cube([9.5,5,5]);
  translate([31.5,9.5,3]) color("red") cube([9.5,5,5]);
  translate([-13,(15.6-10)/2,3]) color("blue") cube([13.5,10,3]);
}

module GPIO(){ 
  translate([0,0,0]) cube([48.2+X,15.5+X,3]);
  translate([47,(15.6-10)/2,3]) color("blue") cube([13.5,10,3]);
  translate([-8,(15.6-10)/2,3]) color("blue") cube([13.5,10,3]);
}

module patch_board(){
  difference(){
    translate([0,0,0]) color("blue") cube([38.75+X,12.1+X,3]);
    translate([35.5,7.5,-5]) cylinder(r=2.8/2, h=15);
  }
}






